/*=======================================================================================================
                                           Обработчик прерывания 2 мс
=======================================================================================================*/
void Timer_Interrupt()
{
  TimeCount++;
  if (TimeCount >= 500)
  {
    Flag_Cels = 1;
    TimeCount = 0;
    FlagSensReady = true;
  }
  if (TimeCount == 0) DS_Cels.reset();                     // сброс шины
  if (TimeCount == 1) DS_Cels.write(0xCC, POWER_MODE);     // пропуск ROM
  if (TimeCount == 2) DS_Cels.write(0x44, POWER_MODE);     // инициализация измерения
  if (TimeCount == 5) Present = DS_Cels.reset();           // Сигнал наличия датчика температуры

  if (TimeCount == 480) DS_Cels.reset();                   // сброс шины
  if (TimeCount == 481) DS_Cels.write(0xCC, POWER_MODE);   // пропуск ROM
  if (TimeCount == 482) DS_Cels.write(0xBE, POWER_MODE);   // команда чтения памяти датчика

  if (TimeCount == 483 ) bufData[0] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 484 ) bufData[1] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 485 ) bufData[2] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 486 ) bufData[3] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 487 ) bufData[4] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 488 ) bufData[5] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 489 ) bufData[6] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 490 ) bufData[7] = DS_Cels.read();      // чтение памяти датчика
  if (TimeCount == 491 ) bufData[8] = DS_Cels.read();      // чтение памяти датчика
}
/*=======================================================================================================
                                              Чтение температуры
=======================================================================================================*/
void Read_DS18B20() 
{
  if (FlagSensReady == true) 
  {
    FlagSensReady = false;                            // Данные готовы

    if (OneWire::crc8(bufData, 8) == bufData[8])      // Проверка CRC данные правильные
    {
      Cels[0] = (float)((int)bufData[0] | (((int)bufData[1]) << 8)) * 0.0625 + 0.03125; 
    }
  }
  Flag_Cels = 0;
}
/*=====================================================================================================*/
