/*=======================================================================================================
                                        Функция работы таймера по прерыванию
=======================================================================================================*/
void Timing_ISR()
{
  Sec[0]++; Sec[1]++; Sec[2]++;
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[0] >= 10)
  {
    Sec[0] = 0;
    if (Blink[0] != 0) {for (byte t = 0; t <= 3; t++) if (Raz_Flag[t] == 1 || Zar_Flag[t] == 1) Sec_C[t]++;}
  }
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[1] >= 600)                                                // Время тикает
  {
    Sec[1] = 0; 
    for (byte t = 0; t <= 3; t++) {if (Zar_Flag[t] == 1) Minute_Z[t]++; if (Raz_Flag[t] == 1) Minute_R[t]++;}
  }
  for (byte t = 0; t <= 3; t++) {if (Minute_Z[t] >= 60) {Minute_Z[t] = 0; Hour_Z[t]++;} 
                                 if (Minute_R[t] >= 60) {Minute_R[t] = 0; Hour_R[t]++;}}
/*-----------------------------------------------------------------------------------------------------*/
  if (Sec[2] == 100)
  {
    Izm_Flag = 2;
  }
/*=====================================================================================================*/
  if (digitalRead(SB_1) == 0)                                       // Баллансир аккумуляторов
  {
    Serial.println(" : SB_1 = Ballansir");
    if (Write == 0)
    {
      if (Akum_Flag[0] == 0 && Akum_Flag[1] == 0 && Akum_Flag[2] == 0 && Akum_Flag[3] == 0) Limit_Flag = 2;
      else Limit_Flag = 0;
      if (Limit_Flag == 0)
      {
        switch (r)
        {
          case 0: 
                  r = 1; Blink[0] = 1; Limit_Ball = 1; 
                  for (byte c = 0; c <= 3; c++) if (Akum_Flag[c] == 1) {Raz_Flag[c] = 1; 
                  Sec[0] = 0; Sec[1] = 0; Sec_C[c] = 0;}
          break;
          case 1: 
                  r = 0; Blink[0] = 0; Limit_Ball = 0; for (byte c = 0; c <= 3; c++) Raz_Flag[c] = 0; 
          break;
        }
        while (digitalRead(SB_1) == 0) {delay(100);}                     // 
      }
      else
      {
        switch (Lim_F)
        {
          case 0: Lim_F = 1; c = 1; Limit_Flag = 1; break;
          case 1: Lim_F = 0; c = 0; Limit_Flag = 0; break;
        }
        Sec[3] = 0; byte w = 0;
        while (digitalRead(SB_1) == 0) 
        {
          if (Sec[3] >= 500)
          {
            Limit_Raz[1] = Limit_Raz[0] / 100;
            Limit_Raz[2] = Limit_Raz[0] - (Limit_Raz[1] * 100);
            switch (w)
            {
              case 0: w = 1; Write = 1; break;
              case 1: w = 2; EEPROM_Write(); break;
            }
          }
//          Serial.println(Sec[3]);
          Sec[3]++; delay(10);
          if (Sec[3] >= 501) goto Loop_W;
        }
      }
      Loop_W:
      Serial.println(" ");   // Здесь должна быть любая команда
    }
  }
/*=====================================================================================================*/
  if (digitalRead(SB_2) == 0)                                       // Заряжаем аккумулятор
  {
    Serial.println(" : SB_2 = Zaryad");
    if (Limit_Flag == 1) Limit_Raz[0]++;
    else
    {
      switch (z)
      {
        case 0: 
              z = 1; Blink[0] = 2; 
              for (byte c = 0; c <= 3; c++) 
              {
                if (Akum_Flag[c] == 1) 
                {
                  Zar_Flag[c] = 1;  Zar(c, 1);                                    // Включили заряд аккумулятора
                  Minute_Z[c] = 0; Hour_Z[c] = 0; Sec[0] = 0; Sec[1] = 0; Sec_C[c] = 0; Curr_O[c] = 0;
                  Cap[c] = 0; Cap_Z[c] = 0; Cap_R[c] = 0; Curr_Z[c] = 0; Curr_R[c] = 0;
                }
              }
        break;
        case 1: 
              z = 0; Blink[0] = 0; 
              for (byte c = 0; c <= 3; c++) 
              {
                if (Akum_Flag[c] == 1) 
                {
                  Zar_Flag[c] = 0;  Zar(c, 0);                                    // Выключили заряд аккумулятора
                  Minute_Z[c] = 0; Hour_Z[c] = 0; Curr_O[c] = 0; Curr_Z[c] = 0; Curr_R[c] = 0;
                  Cap[c] = 0; Cap_Z[c] = 0; Cap_R[c] = 0;
                }
              }
        break;
      }
      while (digitalRead(SB_2) == 0) {delay(100);}                     // 
    }
  }
/*=====================================================================================================*/
  if (analogRead(SB_3) <= 200)                                      // Измеряем емкость аккумулятора
  {
    Serial.println(" : SB_3 = Capaciti");
    switch (ci)
    {
      case 0: 
              ci = 1; Cicl_Flag = 1;  Blink[0] = 1; Blink[1] = 1; 
              for (byte c = 0; c <= 3; c++) if (Akum_Flag[c] == 1) {Raz_Flag[c] = 1; 
              Sec[0] = 0; Sec[1] = 0; Sec_C[c] = 0; Cap[c] = 0; Cap_Z[c] = 0; Cap_R[c] = 0;
              Curr_Z[c] = 0; Curr_R[c] = 0; Curr_O[c] = 0;}
      break;
      case 1:
              ci = 0; Cicl_Flag = 0;  Blink[0] = 0; Blink[1] = 0;
              for (byte c = 0; c <= 3; c++) if (Akum_Flag[c] == 1) {Zar_Flag[c] = 0; Raz_Flag[c] = 0; 
              Sec[0] = 0; Sec[1] = 0; Sec_C[c] = 0; Minute_Z[c] = 0; Hour_Z[c] = 0; Minute_R[c] = 0; Hour_R[c] = 0;
              Curr_Z[c] = 0; Curr_R[c] = 0; Curr_O[c] = 0;}
      break;
    }
    while (analogRead(SB_3) <= 200) {delay(100);}
  }
/*=====================================================================================================*/
  if (analogRead(SB_4) <= 200)                                      // Измеряем внутреннее сопротивление 
  {
    Serial.println(" : SB_4 = Resys");
    if (Limit_Flag == 1) Limit_Raz[0]--;
    else
    {
      while (analogRead(SB_4) <= 200) 
      {
        Res_Flag = 1; delay(100);
        Cap[c] = 0; Cap_Z[c] = 0; Cap_R[c] = 0; Curr_Z[c] = 0; Curr_R[c] = 0; Curr_O[c] = 0;
      }
    }
  }
}
/*=====================================================================================================*/
